'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../../../_virtual/_rollupPluginBabelHelpers.cjs');
var jsCore = require('@lorisleiva/js-core');

/** @group Errors */
class BeetSerializerError extends jsCore.MetaplexError {
  constructor(message, cause) {
    super(message, 'plugin', 'Beet Serializer', cause);
    _rollupPluginBabelHelpers.defineProperty(this, "name", 'BeetSerializerError');
  }
}
class OperationNotSupportedError extends BeetSerializerError {
  constructor(operation) {
    super(`The operation [${operation}] is ` + `not supported by the Beet Serializer.`);
    _rollupPluginBabelHelpers.defineProperty(this, "name", 'OperationNotSupportedError');
  }
}

exports.BeetSerializerError = BeetSerializerError;
exports.OperationNotSupportedError = OperationNotSupportedError;
//# sourceMappingURL=errors.cjs.map
